#include <at91sam7x256.h>
#include <lib_at91sam7x256.h>
#include "usart.h"
#include "VT100.h"
#include "tdelay.h"

#define BOAR_CLK	48000000
enum Menustates {MEN0, MENA, MENB, MENC };

const unsigned char menu0[]  = "Writer...\nPublisher...\nReset\n";
const unsigned char menuA[]  = "Mohammad.\nMazarei.\nBack\n";
const unsigned char menuB[]  = "Kavir\nElectronic\nBack\n";
const unsigned char menuC[]  = "WD-Reset\nNo Reset\n";

int main(void){
 char i,ret;
 enum Menustates state = MEN0;
init_delay();
// Activ Power USART 0
AT91C_BASE_PMC->PMC_PCER = (1<<AT91C_ID_US0); // OR AT91C_ID_US1
USART_Configure_PIO(USART0_PORT,TXD0);// SET TXD0 TO USART
USART_Configure_PIO(USART0_PORT,RXD0);// SET RXD0 TO USART



USART_Configure(USART0,USART_MODE_ASYNCHRONOUS,38400, BOAR_CLK); // Config Usart0
USART_SetTransmitterEnabled(USART0, 1); // ENABLE Transmitter
USART_SetReceiverEnabled(USART0, 1); //  Enable Receiver

USART_Write(USART0,65,0);
SATAT:
ret=1;
state = MEN0;
Term_Initialise();      // Initialize terminal server
Term_Set_Display_Colour( COL_BACKGROUND, COL_BLACK  );
Term_Set_Display_Colour( COL_FOREGROUND, COL_WHITE  );
Term_Erase_Screen();
	
	Term_Draw_Frame(7,18,5,45,0);
	Term_Set_Cursor_Position(9,20);
	Term_Send_FlashStr( "Atmel/Arm Terminal Vt100 Demo (M.Mazarei)" );
	Term_Set_Display_Colour( COL_FOREGROUND, COL_CYAN );
	Term_Set_Display_Attribute_Mode(MODE_BLINK);
	Term_Set_Cursor_Position(11,35);
	Term_Send_FlashStr("Standby...");
	Term_Set_Display_Attribute_Mode(MODE_NONE);

	Term_Set_Display_Colour( COL_FOREGROUND, COL_RED );
	Term_Set_Display_Attribute_Mode(MODE_BOLD);
	Term_Save_Cursor_Position();

	for ( i=20; i>1; i-- ) {
	Term_Restore_Cursor_Position();
	Term_Send_Value_as_Digits(i-1);
	delay_ms(250);
	}


	Term_Set_Display_Attribute_Mode(MODE_NONE);
	
	while (1) {
	
		Term_Erase_Screen();
	
		/* Handle menus in a primitive state-maschine */
		switch (state) {
				
			case MEN0 : 	
				ret = Term_Handle_Menu( menu0, 1, 10, 10, 1 );
				switch (ret) {
					case 1 : state = MENA; break;
					case 2 : state = MENB; break;
					case 3 : state = MENC; break;
				}
				break;
				
			case MENA : 	
				ret = Term_Handle_Menu( menuA, 1, 10, 10, 1 );
				switch (ret) {
					case 3 : state = MEN0; break;
				}
				break;
			
			case MENB : 	
				ret = Term_Handle_Menu( menuB, 1, 10, 10, 1 );
				switch (ret) {
					case 3 : state = MEN0; break;
				}
				break;
			
			case MENC : 	
				ret = Term_Handle_Menu( menuC, 2, 10, 10, 1 );
				switch (ret) {
					case 1 : 
						goto SATAT;
						
						break;
					case 2 : state = MEN0; break;
				}
				break;
			
		} 
		
	}



}
